#  MR-Vote 0.01, Copyright (C) 2001 Yamamoto Takanori
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

#extern $JCODE_EXT, $JCODE_INT
#extern &jcode'convert(), FileHandle


sub AppendCSV(){
    my($fn) = shift;
    my($paItem) = shift;

    local($output);
    my($k);
    foreach $k (@$paItem){
        $k =~ s/\"/\"\"/g;
	$k =~ s/[\x00-\x1f]//g;
        $output .= "\"$k\",";
    }
    chop($output); $output.="\n";
    &jcode'convert(*output, $JCODE_EXT);

    my($fp) = new FileHandle;
    open($fp, ">>$fn");
    chmod 0600, $fn; # for the safety
    flock($fp, 2); seek($fp, 0, 2); #file lock
    print $fp $output;
    flock($fp, 8); # file unlock
    close($fp);
}


sub ReadCSV(){
    my($fn) = shift;
    my($paData) = shift;

    my($fp) = new FileHandle;
    open($fp, $fn);
    flock($fp, 2); #file lock
    my($i) = 1+($#$paData); # append
    while(<$fp>){
	chomp;
        local($tmp) = $_;
	if($tmp eq ''){next;}
        &jcode'convert(*tmp, $JCODE_INT);
        my(@items) = &SplitCSV($tmp);
        $$paData[$i] = \@items;
        $i++;
    }
    flock($fp, 8); # file unlock
    close($fp);
}


sub SplitCSV(){
    my($s) = shift;
    my(@result, @iterator);
    $iterator[0] = $iterator[1] = $iterator[2] = $iterator[3] = 0;
    $s =~ s/(.)/&SplitCSV_inner(\@result,\@iterator,$1)/geo;
    return @result;
}


sub SplitCSV_inner(){
    my($pr) = shift;
    my($pi) = shift;
    my($c) = shift;

    if($c eq ','){
	if($$pi[3]){
	    if($$pi[1]==1){
		($$pi[2])++;
		$$pr[($$pi[0])] .= ',';
	    }else{
		($$pi[0])++; # record index
		($$pi[1])=0; # quote appearance
		($$pi[2])=0; # chrs
		($$pi[3])=0; # quoted record flag
	    }
	}else{
	    ($$pi[0])++; # record index
	    ($$pi[1])=0; # quote appearance
	    ($$pi[2])=0; # chrs
	    ($$pi[3])=0; # quoted record flag
	}
    }elsif($c eq '"'){
	($$pi[1])++;
	if(($$pi[2])==0){
	    ($$pi[3])=1;
	}elsif(($$pi[1])==($$pi[3])+2){
	    ($$pi[1])-=2;
	    ($$pi[2])++;
	    $$pr[($$pi[0])] .= '"';
	}else{
	    # half-wing. nop.
	}
    }else{
	if($$pi[1]>($$pi[3])){
	    ($$pi[1])--; # broken-wing. funny.
	    ($$pi[2])++;
	    $$pr[($$pi[0])] .= '"';
	}
	($$pi[2])++;
	$$pr[($$pi[0])] .= $c;
    }
    return $c;
}


1;

